#ifndef __TWI_DRV_HEADER__
#define __TWI_DRV_HEADER__

#include <avr/io.h>


#define __APPLY_TWI_TIMEOUT__
//#define __APPLY_I2C_SW_RESET__

#define REG_ADDR_BITSIZE_8				8
#define REG_ADDR_BITSIZE_16				16


extern uint32_t TWI_Initialize(TWI_t *, uint32_t fperi_clk, uint32_t twi_speed);

extern uint32_t TWI_Write(TWI_t *, uint8_t, uint8_t, uint16_t, uint8_t *, uint32_t);
extern uint32_t TWI_Read(TWI_t *, uint8_t, uint8_t, uint16_t, uint8_t *, uint32_t);

//TWI_Write(TWI0, EEPROM_SLAVE_DEV_ADDR, REG_ADDR_BITSIZE_16, 0, buf, BUF_SIZE)
//uint32_t TWI_Write(TWI_t *ptwi, uint8_t dev_addr, uint8_t addr_size, uint16_t reg_addr, uint8_t *pbuf, uint32_t size)
#ifdef __APPLY_I2C_SW_RESET__
extern void Do_SW_Reset(TWI_t *);
#endif

#endif		/* End of __TWI_DRV_HEADER__ */
